//** Modified-Light version of OpenGL_drawer for TP**// 


#ifndef   	OPENGL_DRAWER_H_
# define   	OPENGL_DRAWER_H_


#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>
#include <GL/glut.h>
#include <GL/glext.h>
using namespace std;

#include <Navigator_tool.h>
#include <Mesh_object.h>
#include <Segment.h>
#include <Triangle.h>
#include <Polygon.h>
#include <Drawable_mesh.h>

#include <Texture.h>

class OpenGL_drawer
{

 public:

  OpenGL_drawer();
  ~OpenGL_drawer();


  int draw_mesh_slow(Mesh_object& mesh);
  int draw_mesh_grid(Mesh_object& mesh);
  int init_opengl(int arc,char **argv,const Navigator_tool& navigator);


  int draw_segment(const Segment& s) const;
  int draw_triangle(const Triangle& t) const;
  int draw_polygon(const Polygon& p) const;

  GLuint load_texture(const char* filename);

  double draw_fps(const Navigator_tool& navigator) const;

  /// add a mesh into the draw list
  GLint add_draw_list(Drawable_mesh& _mesh,const string& name);
  /// add a mesh into the draw list
  GLint add_draw_list(const Mesh_object& _mesh);
  /// set a draw list at index k_list
  /** if k_list==-1, then add at the end */
  GLint set_draw_list(int k_list,Drawable_mesh& _mesh,const string& name);
  /// set a draw list at index k_list
  /** if k_list==-1, then add at the end */
  GLint set_draw_list(int k_list,const Mesh_object& _mesh);  
  /// set a draw list corresponding to mesh.get_draw_list() at index k_list
  /** if k_list==-1, then add at the end 
      Assume the draw_list is already created. If not, add it.
   */
  GLint update_draw_list(const Mesh_object& _mesh);  


  /// draw every stored list
  int draw_stored_list() const;
  /// draw the mesh stored in position k_list
  int draw_in_list(int k_list) const;

 private:
  
  std::vector <GLint> draw_list;
  std::vector <string> name_mesh;
  
  
};

#endif 	    /* !OPENGL_DRAWER_H_ */
