
//** Modified-Light version of Mesh_object_loader for TP**// 

#include <Mesh_object_loader.h>


Mesh_object_loader::Mesh_object_loader(){}
Mesh_object_loader::~Mesh_object_loader(){}



int Mesh_object_loader::load_obj_texture(const std::string& filename,Mesh_object* mesh) const
{


  //1. Read texture vector

#define SIZE_BUFFER 2048
  char buffer[SIZE_BUFFER]={'\0'};
  char buffer2[SIZE_BUFFER]={'\0'};
  
  FILE *fid=NULL;
  fid=fopen(filename.data(),"r");
  if(fid==NULL)
    {printf("ERROR loading %s in load_obj_texture in Mesh_object_helper\n",filename.data());exit(-1);}
  
  float X[2];
  while(fscanf(fid,"%s",buffer)!=EOF)
    {
      if(strcmp(buffer,"vt")==0)
	{
	  if(fscanf(fid,"%f %f\n",X,X+1)!=2)
	    {printf("Error reading texture in load_obj_texture in Mesh_object_loader\n");exit(-1);}
	  mesh->add_intermediate_texture(X[0],X[1]);
	}
      else //read the whole line
	fgets(buffer,sizeof(buffer),fid);
    }


  rewind(fid);

  //2. now read the indexed texture

  std::vector <int> poly;
  int ct=0;
  int one=-1;
  while(fscanf(fid,"%s",buffer)!=EOF)
    {
      switch(buffer[0])
	{
	case 'f': //polygon faces
	  poly.resize(0);
	  strcpy(buffer2,"\0");
	  fscanf(fid,"%s",buffer2);

	  if(sscanf(buffer2,"%*d/%d/%*d",&ct)==1)
	    {
	      poly.push_back(ct+one);
	      while(fscanf(fid,"%*d/%d/%*d",&ct)==1)
		poly.push_back(ct+one);
	      mesh->add_polygon_texture(poly);
	    }
	  else if(sscanf(buffer2,"%*d/%d",&ct)==1)
	    {
	      poly.push_back(ct+one);
	      while(fscanf(fid,"%d/%*d",&ct)==1)
		poly.push_back(ct+one);
	      mesh->add_polygon_texture(poly);
	    }
	  else //read the whole line
	    fgets(buffer,sizeof(buffer),fid);
	  break;
	}
    }





  if(fclose(fid)!=0)
    {printf("ERROR closing %s in load_obj_texture in Mesh_object_loader\n",filename.data());exit(-1);}
  return 0;
}

int Mesh_object_loader::load_obj_texture(const char* filename,Mesh_object* mesh) const
{std::string file=filename;return load_obj_texture(file,mesh);}



int Mesh_object_loader::load_color_per_vertex_coff(const std::string& filename,Mesh_object* mesh)
{
  mesh->set_per_vertex_color();

#define SIZE_BUFFER 2048
  char buffer[SIZE_BUFFER]={'\0'};
  
  FILE *fid=NULL;
  fid=fopen(filename.data(),"r");
  if(fid==NULL)
    {printf("ERROR loading %s in load_off_file in load_color_per_vertex_coff in Mesh_object_loader \n",filename.data());exit(-1);}



  while(strcmp(buffer,"COFF")!=0)
    {
      if(fscanf(fid,"%s",buffer)==EOF)
	{printf("ERROR file %s is not coff file (in Mesh_object_loader)\n",filename.data());exit(-1);}
      if(buffer[0]=='#')//comments
	fgets(buffer,sizeof(buffer),fid);
    }

  //pass comments
  fscanf(fid,"%s",buffer);
  while(buffer[0]=='#')//comments
    {
      fgets(buffer,sizeof(buffer),fid);
      fscanf(fid,"%s",buffer);
    }


  //read Number of vertices
  int N_vertex=0;
  int k_vertex=0;
  N_vertex=atoi(buffer);//N_vertex
  fgets(buffer,sizeof(buffer),fid);//read line



  float C[4]={0.0,0.0,0.0,0.0};
  while(k_vertex<N_vertex)
    {
      if(fscanf(fid,"%*f %*f %*f %f %f %f %f",C,C+1,C+2,C+3)!=4)
	{
	  fscanf(fid,"%s",buffer);
	  if(buffer[0]!='#')
	    {printf("ERROR loading %s in Mesh_object_loader in load_color_per_vertex_coff\n",filename.data());exit(-1);}
	  else//read line
	    fgets(buffer,sizeof(buffer),fid);
	}
      else
	{
	  mesh->set_per_vertex_color(k_vertex,C[0],C[1],C[2],C[3]);
	  k_vertex++;
	}
    }

  if(fclose(fid)!=0)
    {printf("ERROR closing %s in load_color_per_vertex_coff in Mesh_object_loader\n",filename.data());exit(-1);}

  return 0;
}
int Mesh_object_loader::load_color_per_vertex_coff(const char* filename,Mesh_object* mesh)
{return load_color_per_vertex_coff(std::string(filename),mesh);}

