//** Modified-Light version of Vector_parameter for TP**// 

#include <Vector_parameter.h>

Vector_parameter::Vector_parameter()
{}

Vector_parameter::Vector_parameter(const Vector_parameter& v)
{
  vector_int = v.vector_int;
  vector_double = v.vector_double;
}
Vector_parameter::~Vector_parameter()
{
  destroy();
}

int Vector_parameter::destroy()
{
  vector_int.resize(0);
  vector_double.resize(0);
  return 0;
}



int Vector_parameter::size_int() const {return vector_int.size();}
int Vector_parameter::size_double() const {return vector_double.size();}
int Vector_parameter::resize_int(int N_size) {vector_int.resize(N_size);return 0;}
int Vector_parameter::resize_double(int N_size) {vector_double.resize(N_size);return 0;}

int Vector_parameter::size_int(int k_vector) const 
{
  if(k_vector<0 || k_vector>=size_int())
    {printf("Error in size_int(%d) in Vector_parameter, size=%d\n",k_vector,size_int());exit(-1);}
  return vector_int[k_vector].size();
}
int Vector_parameter::size_double(int k_vector) const
{
  if(k_vector<0 || k_vector>=size_double())
    {printf("Error in size_int(%d) in Vector_parameter, size=%d\n",k_vector,size_double());exit(-1);}
  return vector_double[k_vector].size();
}
int Vector_parameter::resize_int(int k_vector,int N_size)
{
  if(k_vector<0 || k_vector>=size_int())
    {printf("Error in resize_int(%d,%d) in Vector_parameter, size=%d\n",k_vector,N_size,size_int());exit(-1);}
  vector_int[k_vector].resize(N_size);
  return 0;
}
int Vector_parameter::resize_double(int k_vector,int N_size)
{
  if(k_vector<0 || k_vector>=size_double())
    {printf("Error in resize_double(%d,%d) in Vector_parameter, size=%d\n",k_vector,N_size,size_double());exit(-1);}
  vector_double[k_vector].resize(N_size);
  return 0;
}



const int_vector& Vector_parameter::get_int(int k_index) const
{
  if(k_index<0 || k_index>=size_int())
    {printf("Error in get_int(%d) in Vector_parameter, size=%d\n",k_index,size_int());exit(-1);}
  return vector_int[k_index];
}
int_vector& Vector_parameter::get_int(int k_index)
{
  if(k_index<0 || k_index>=size_int())
    {printf("Error in get_int(%d) in Vector_parameter, size=%d\n",k_index,size_int());exit(-1);}
  return vector_int[k_index];
}

const double_vector& Vector_parameter::get_double(int k_index) const
{
  if(k_index<0 || k_index>=size_double())
    {printf("Error in get_double(%d) in Vector_parameter, size=%d\n",k_index,size_double());exit(-1);}  
  return vector_double[k_index];
}

double_vector&  Vector_parameter::get_double(int k_index)
{
  if(k_index<0 || k_index>=size_double())
    {printf("Error in get_double(%d) in Vector_parameter, size=%d\n",k_index,size_double());exit(-1);}  
  return vector_double[k_index];
}


int& Vector_parameter::get_int(int k_vector,int k_index)
{
  if(k_vector<0 || k_vector>=size_int())
    {printf("Error in get_int(%d,%d) in Vector_parameter, size=%d\n",k_vector,k_index,size_int());exit(-1);}
  return vector_int[k_vector][k_index];
}
int Vector_parameter::get_int(int k_vector,int k_index) const
{
  if(k_vector<0 || k_vector>=size_int())
    {printf("Error in get_int(%d,%d) in Vector_parameter, size=%d\n",k_vector,k_index,size_int());exit(-1);}
  return vector_int[k_vector][k_index];
}

double& Vector_parameter::get_double(int k_vector,int k_index)
{
  if(k_vector<0 || k_vector>=size_double())
    {printf("Error in get_double(%d,%d) in Vector_parameter, size=%d\n",k_vector,k_index,size_double());exit(-1);}
  return vector_double[k_vector][k_index];
}
double  Vector_parameter::get_double(int k_vector,int k_index) const
{
  if(k_vector<0 || k_vector>=size_double())
    {printf("Error in get_double(%d,%d) in Vector_parameter, size=%d\n",k_vector,k_index,size_double());exit(-1);}
  return vector_double[k_vector][k_index];
}

Vector_parameter& Vector_parameter::operator=(const Vector_parameter& p)
{
  vector_int    = p.vector_int;
  vector_double = p.vector_double;

  return (*this);
}
