//** Modified-Light version of double_vector for TP**// 




#include <double_vector.h>

double_vector::double_vector():
double_list()
{
  double_list.resize(0);
}

double_vector::double_vector(const double_vector &_V):
  double_list()
{
  double_list.resize(_V.double_list.size());
  for(int k=0;k<int(double_list.size());double_list[k]=_V.double_list[k],k++){};
}

double_vector::~double_vector()
{
  double_list.resize(0);
}

int double_vector::size() const
{
  return double_list.size();
}

int double_vector::resize(int _size)
{
  if(_size>=0)
    {
      double_list.resize(_size);
      return(0);
    }
  else
    {printf("error in resize in double_vector, size[%d] is not correct\n",_size);exit(-1);}

  return(-1);
}

double& double_vector::operator[](int k_vertex)
{
  if(k_vertex<0 || k_vertex>=int(double_list.size()))
    {printf("Error in operator [] in double_vector, k_vertex [%d] is not correct because double_list.size()=[%d] \n",k_vertex,double_list.size());exit(-1);}
  return double_list[k_vertex];
}  
double double_vector::operator[](int k_vertex) const
{
  if(k_vertex<0 || k_vertex>=int(double_list.size()))
    {printf("Error in operator [] in double_vector, k_vertex [%d] is not correct because double_list.size()=[%d] \n",k_vertex,double_list.size());exit(-1);}
  return double_list[k_vertex];
}  


double_vector& double_vector::operator=(const double_vector& _V)
{
  double_list.resize(_V.double_list.size());
  for(int k=0;k<int(_V.double_list.size());k++)
    double_list[k] = _V.double_list[k];
  return *this;
}


int double_vector::add(double value)
{
  double_list.push_back(value);
  return(0);
}

int double_vector::add(std::vector <double>& _double_list)
{
  int k=0;
  for(k=0;k<int(_double_list.size());k++)
    add(_double_list[k]);
  return 0;
}

bool operator==(const double_vector& cont_1,const double_vector& cont_2)
{
  double epsilon=0.00001;
  if(cont_1.size()!=cont_2.size())
    return 0;
  for(int k=0;k<int(cont_1.size());k++)
    if(fabs(cont_1[k]-cont_2[k])>epsilon)
      return 0;
  return 1;
}
bool operator!=(const double_vector& cont_1,const double_vector& cont_2)
{
  if(cont_1==cont_2)
    return 0;
  return 1;
}
